<template>
  <div>
    <div class="subtitle-2"><b>Ceco</b><span class="tRojo">*</span></div>
    <v-autocomplete
      v-model="data.value"
      :items="cecos"
      item-text="descripcion"
      item-value="idCeco"
      label="Busca ceco"
      :cache-items="false"
      single-line
      return-object
      :search-input.sync="textoIngresado"
      :filter="customFilter"
      @keyup="getCecos()"
      @change="seleccionCeco()"
      :disabled="disabled"
    >
    </v-autocomplete>
    <v-checkbox
      v-model="noExisteCeco"
      :label="`No encontraste tu ceco?`"
      :disabled="disabled"
    ></v-checkbox>
    <div v-if="noExisteCeco">
      <v-text-field
        v-model.trim="value.dataCeco.ceco"
        maxlength="6"
        placeholder="Digita el ceco"
        @input="digitarCeco()"
        @click="borrarDatosGenerales()"
        ref="txtCeco"
        counter
        :disabled="disabled"
      />
    </div>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-ListaCeco",
  props: {
    value: Object,
    disabled: Boolean,
    callback: { type: Function },
    borrarDatos: { type: Function },
  },
  computed: {
    data: {
      get() {
        return this.retornoValorGet();
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  data() {
    return {
      cecos: [],
      textoIngresado: null,
      noExisteCeco: false,
    };
  },
  methods: {
    customFilter(item, queryText, itemText) {
      const textOne = item.descripcion.toLowerCase();
      const textTwo = item.idCeco.toString();
      const searchText = queryText.toLowerCase();
      return (
        textOne.indexOf(searchText) > -1 || textTwo.indexOf(searchText) > -1
      );
    },
    getCecos() {
      var self = this;
      this.cecos = [];
      if (this.textoIngresado != null && this.textoIngresado.length > 3) {
        var idNegocioVar = this.value.dataUnidadNegocio.value.idNegocio;
        if (idNegocioVar == "-1") {
          idNegocioVar = null;
        }
        var body = {
          idNegocio: idNegocioVar,
          ceco: this.textoIngresado,
        };
        axios
          .post("/documento-sucursal/ceco/v1/busquedas/", body)
          .then((response) => {
            let data = response.data;
            if (data) {
              this.noExisteCeco = false;
              self.cecos = data.resultado.cecos;
            }
          })
          .catch((error) => {
            if (error.response) {
              if (error.response.status == 404) {
                this.noExisteCeco = true;
              }
              console.log(error.response.data);
            }
          });
      }
    },

    retornoValorGet() {
      return this.value.dataCeco;
    },

    digitarCeco() {
      console.log("digitarCeco");
      this.value.dataCeco.value = "";
      if (
        this.value.dataCeco.ceco != null &&
        this.value.dataCeco.ceco.length == 6 &&
        typeof this.value.dataUnidadNegocio.value != "string"
      ) {
        this.callback();
      } else {
        console.log("callback borrarDatos");
        this.borrarDatos(5);
      }
    },

    reset() {
      this.cecos = [];
    },

    borrarDatosGenerales() {
      this.borrarDatos(5);

      this.$refs.txtCeco.clearableCallback();
    },

    seleccionCeco() {
      console.log("seleccionCeco");
      this.value.dataCeco.ceco = this.value.dataCeco.value.idCeco;
      this.callback();
    },
  },
  created() {
    console.log("createListaCecoComponente");
    console.log("disabled:" + this.disabled);
  },
};
</script>
